/*! @algolia/autocomplete-plugin-redirect-url 1.19.2 | MIT License | © Algolia, Inc. and contributors | https://github.com/algolia/autocomplete */
(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
  typeof define === 'function' && define.amd ? define(['exports'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["@algolia/autocomplete-plugin-redirect-url"] = {}));
})(this, (function (exports) { 'use strict';

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      enumerableOnly && (symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      })), keys.push.apply(keys, symbols);
    }
    return keys;
  }
  function _objectSpread2(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = null != arguments[i] ? arguments[i] : {};
      i % 2 ? ownKeys(Object(source), !0).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
    return target;
  }
  function _defineProperty(obj, key, value) {
    key = _toPropertyKey(key);
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }
    return obj;
  }
  function _toPrimitive(input, hint) {
    if (typeof input !== "object" || input === null) return input;
    var prim = input[Symbol.toPrimitive];
    if (prim !== undefined) {
      var res = prim.call(input, hint || "default");
      if (typeof res !== "object") return res;
      throw new TypeError("@@toPrimitive must return a primitive value.");
    }
    return (hint === "string" ? String : Number)(input);
  }
  function _toPropertyKey(arg) {
    var key = _toPrimitive(arg, "string");
    return typeof key === "symbol" ? key : String(key);
  }

  var warnCache = {
    current: {}
  };

  /**
   * Logs a warning if the condition is not met.
   * This is used to log issues in development environment only.
   */
  function warn(condition, message) {
    if (condition) {
      return;
    }
    var sanitizedMessage = message.trim();
    var hasAlreadyPrinted = warnCache.current[sanitizedMessage];
    if (!hasAlreadyPrinted) {
      warnCache.current[sanitizedMessage] = true;

      // eslint-disable-next-line no-console
      console.warn("[Autocomplete] ".concat(sanitizedMessage));
    }
  }

  /** @jsxRuntime classic */
  /** @jsx createElement */

  var defaultTemplates = {
    item: function item(_ref) {
      var createElement = _ref.createElement,
        item = _ref.item,
        state = _ref.state;
      return createElement("div", {
        className: "aa-ItemWrapper"
      }, createElement("div", {
        className: "aa-ItemContent"
      }, createElement("div", {
        className: "aa-ItemIcon aa-ItemIcon--noBorder"
      }, createElement("svg", {
        viewBox: "0 0 24 24",
        fill: "currentColor"
      }, createElement("path", {
        d: "M16.041 15.856c-0.034 0.026-0.067 0.055-0.099 0.087s-0.060 0.064-0.087 0.099c-1.258 1.213-2.969 1.958-4.855 1.958-1.933 0-3.682-0.782-4.95-2.050s-2.050-3.017-2.050-4.95 0.782-3.682 2.050-4.95 3.017-2.050 4.95-2.050 3.682 0.782 4.95 2.050 2.050 3.017 2.050 4.95c0 1.886-0.745 3.597-1.959 4.856zM21.707 20.293l-3.675-3.675c1.231-1.54 1.968-3.493 1.968-5.618 0-2.485-1.008-4.736-2.636-6.364s-3.879-2.636-6.364-2.636-4.736 1.008-6.364 2.636-2.636 3.879-2.636 6.364 1.008 4.736 2.636 6.364 3.879 2.636 6.364 2.636c2.125 0 4.078-0.737 5.618-1.968l3.675 3.675c0.391 0.391 1.024 0.391 1.414 0s0.391-1.024 0-1.414z"
      }))), createElement("div", {
        className: "aa-ItemContentBody"
      }, createElement("div", {
        className: "aa-ItemContentTitle"
      }, createElement("a", {
        className: "aa-ItemLink",
        href: item.urls[0]
      }, state.query)))), createElement("div", {
        className: "aa-ItemActions"
      }, createElement("div", {
        className: "aa-ItemActionButton"
      }, createElement("svg", {
        viewBox: "0 0 24 24",
        fill: "none",
        stroke: "currentColor",
        strokeWidth: "2",
        strokeLinecap: "round",
        strokeLinejoin: "round"
      }, createElement("line", {
        x1: "5",
        y1: "12",
        x2: "19",
        y2: "12"
      }), createElement("polyline", {
        points: "12 5 19 12 12 19"
      })))));
    }
  };

  function defaultTransformResponse(response) {
    var _renderingContent, _renderingContent$red;
    return (_renderingContent = response.renderingContent) === null || _renderingContent === void 0 ? void 0 : (_renderingContent$red = _renderingContent.redirect) === null || _renderingContent$red === void 0 ? void 0 : _renderingContent$red.url;
  }
  function defaultTransformResponseToQuery(response) {
    return response.query;
  }
  function defaultOnRedirect(redirects, _ref) {
    var _item$urls;
    var event = _ref.event,
      navigator = _ref.navigator,
      state = _ref.state;
    var item = redirects[0];
    var itemUrl = item === null || item === void 0 ? void 0 : (_item$urls = item.urls) === null || _item$urls === void 0 ? void 0 : _item$urls[0];
    if (!itemUrl) {
      return;
    }
    if (event.metaKey || event.ctrlKey) {
      navigator.navigateNewTab({
        itemUrl: itemUrl,
        item: item,
        state: state
      });
    } else if (event.shiftKey) {
      navigator.navigateNewWindow({
        itemUrl: itemUrl,
        item: item,
        state: state
      });
    } else {
      navigator.navigate({
        itemUrl: itemUrl,
        item: item,
        state: state
      });
    }
  }
  function getOptions(options) {
    return _objectSpread2({
      transformResponse: defaultTransformResponse,
      transformResponseToQuery: defaultTransformResponseToQuery,
      templates: defaultTemplates,
      onRedirect: defaultOnRedirect
    }, options);
  }
  function getRedirectData(_ref2) {
    var _redirectUrlPlugin$da;
    var state = _ref2.state;
    var redirectUrlPlugin = state.context.redirectUrlPlugin;
    return (_redirectUrlPlugin$da = redirectUrlPlugin === null || redirectUrlPlugin === void 0 ? void 0 : redirectUrlPlugin.data) !== null && _redirectUrlPlugin$da !== void 0 ? _redirectUrlPlugin$da : [];
  }
  function createRedirectUrlPlugin() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var _getOptions = getOptions(options),
      transformResponse = _getOptions.transformResponse,
      transformResponseToQuery = _getOptions.transformResponseToQuery,
      templates = _getOptions.templates,
      onRedirect = _getOptions.onRedirect;
    function createRedirects(_ref3) {
      var _state$context$redire, _state$context$redire2;
      var results = _ref3.results,
        source = _ref3.source,
        state = _ref3.state;
      var redirect = {
        sourceId: source.sourceId,
        urls: results.map(function (result) {
          return transformResponse(result);
        }).filter(function (url) {
          return url !== undefined;
        })
      };
      var redirects = (_state$context$redire = (_state$context$redire2 = state.context.redirectUrlPlugin) === null || _state$context$redire2 === void 0 ? void 0 : _state$context$redire2.data) !== null && _state$context$redire !== void 0 ? _state$context$redire : [];
      var existingRedirectIndex = redirects.findIndex(function (r) {
        return r.sourceId === source.sourceId;
      });
      if (existingRedirectIndex !== -1) {
        if (redirect.urls.length === 0) {
          redirects.splice(existingRedirectIndex, 1);
        } else {
          redirects[existingRedirectIndex] = redirect;
        }
      } else if (redirect.urls.length > 0) {
        redirects.push(redirect);
      }
      return redirects;
    }
    return {
      name: 'aa.redirectUrlPlugin',
      subscribe: function subscribe(_ref4) {
        var onResolve = _ref4.onResolve,
          onSelect = _ref4.onSelect,
          setContext = _ref4.setContext,
          setIsOpen = _ref4.setIsOpen;
        onResolve(function (_ref5) {
          var results = _ref5.results,
            source = _ref5.source,
            state = _ref5.state;
          // Ensure the resolved response matches the input query text before processing redirects.
          var matchesCurrentQuery = results.some(function (result) {
            return transformResponseToQuery(result) === state.query;
          });
          if (!matchesCurrentQuery) {
            return;
          }
          setContext(_objectSpread2(_objectSpread2({}, state.context), {}, {
            redirectUrlPlugin: {
              data: createRedirects({
                results: results,
                source: source,
                state: state
              })
            }
          }));
        });
        onSelect(function (_ref6) {
          var state = _ref6.state;
          var redirects = getRedirectData({
            state: state
          });
          if (redirects.length > 0) {
            setIsOpen(true);
          }
        });
      },
      reshape: function reshape(_ref7) {
        var _data, _state$context$redire3;
        var state = _ref7.state,
          sourcesBySourceId = _ref7.sourcesBySourceId;
        var redirects = (_data = (_state$context$redire3 = state.context.redirectUrlPlugin) === null || _state$context$redire3 === void 0 ? void 0 : _state$context$redire3.data) !== null && _data !== void 0 ? _data : [];
        redirects.forEach(function (redirect) {
          var source = sourcesBySourceId[redirect.sourceId];
          if (source === undefined) {
            return;
          }
          sourcesBySourceId[redirect.sourceId] = _objectSpread2(_objectSpread2({}, source), {}, {
            getItems: function getItems() {
              return source.getItems().filter(function (item) {
                if (source.getItemInputValue.__default) {
                  "development" !== 'production' ? warn(false, "The source ".concat(JSON.stringify(source.sourceId), " does not have a `getItemInputValue` function. It's required to be able to filter out the redirect item.") + '\nSee https://www.algolia.com/doc/ui-libraries/autocomplete/core-concepts/sources/#param-getiteminputvalue') : void 0;
                  return true;
                }
                var itemInputValue = source.getItemInputValue({
                  item: item,
                  state: state
                });
                if (itemInputValue === undefined) {
                  "development" !== 'production' ? warn(false, "The source ".concat(JSON.stringify(source.sourceId), " does not return a string from the `getItemInputValue` function. It's required to be able to filter out the redirect item.") + '\nSee https://www.algolia.com/doc/ui-libraries/autocomplete/core-concepts/sources/#param-getiteminputvalue') : void 0;
                  return true;
                }
                return itemInputValue.toLowerCase() !== state.query.toLowerCase();
              });
            }
          });
        });
        var redirectSource = {
          sourceId: 'redirectUrlPlugin',
          templates: templates,
          getItemUrl: function getItemUrl(_ref8) {
            var item = _ref8.item;
            return item.urls[0];
          },
          onSelect: function onSelect(_ref9) {
            var event = _ref9.event,
              item = _ref9.item,
              state = _ref9.state,
              navigator = _ref9.navigator;
            onRedirect([item], {
              event: event,
              navigator: navigator,
              state: state
            });
          },
          getItemInputValue: function getItemInputValue() {
            return state.query;
          },
          onActive: function onActive() {},
          getItems: function getItems() {
            return getRedirectData({
              state: state
            });
          }
        };
        "development" !== 'production' ? warn(sourcesBySourceId.redirect === undefined, 'A source with `sourceId: "redirect"` already exists. This source will be overridden.') : void 0;
        return {
          sourcesBySourceId: _objectSpread2({
            // Our source has templates, but reshape only accepts sources without templates (autocomplete-core)
            redirect: redirectSource
          }, sourcesBySourceId),
          state: state
        };
      },
      onSubmit: function onSubmit(_ref10) {
        var event = _ref10.event,
          navigator = _ref10.navigator,
          state = _ref10.state;
        onRedirect(getRedirectData({
          state: state
        }), {
          event: event,
          navigator: navigator,
          state: state
        });
      },
      __autocomplete_pluginOptions: options
    };
  }

  exports.createRedirectUrlPlugin = createRedirectUrlPlugin;
  exports.defaultTemplates = defaultTemplates;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=index.development.js.map
